# Copyright (C) 2006-2008 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

import FenceDeviceAttr
from TagObject import TagObject

TAG_NAME = "device"
OPTION = "option"

class Device(TagObject):
  def __init__(self):
    TagObject.__init__(self)
    self.TAG_NAME = TAG_NAME
    self.agent_type = ""
    self.has_native_option_set = False
    self.fi_attrs = FenceDeviceAttr.FENCE_FI_ATTRS
    self.pretty_fence_names = FenceDeviceAttr.FENCE_OPTS
    self.pretty_name_attrs = FenceDeviceAttr.PRETTY_NAME_ATTRS

  def getAgentType(self):
    return self.agent_type

  def setAgentType(self, agent_type):
    self.agent_type = agent_type

  def hasNativeOptionSet(self):
    return self.has_native_option_set

  def isPowerController(self):
    return self.agent_type in FenceDeviceAttr.FENCE_POWER_CONTROLLERS

  def addAttribute(self, name, value):
    if name == OPTION:
      self.has_native_option_set = True
    self.attr_hash[name] = value
